
/* Chrysalide - Outil d'analyse de fichiers binaires
 * expression.h - prototypes pour la gestion des expressions décompilées
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPRESSION_H
#define _DECOMP_EXPRESSION_H


#include <glib-object.h>



#define G_TYPE_DEC_EXPRESSION               g_dec_expression_get_type()
#define G_DEC_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dec_expression_get_type(), GDecExpression))
#define G_IS_DEC_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dec_expression_get_type()))
#define G_DEC_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DEC_EXPRESSION, GDecExpressionClass))
#define G_IS_DEC_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DEC_EXPRESSION))
#define G_DEC_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DEC_EXPRESSION, GDecExpressionClass))



/* Définition d'une expression décompilée (instance) */
typedef struct _GDecExpression GDecExpression;

/* Définition d'une expression décompilée (classe) */
typedef struct _GDecExpressionClass GDecExpressionClass;


/* Indique le type défini pour une expression décompilée. */
GType g_dec_expression_get_type(void);

/* Réalise une négation sur une expression décompilée. */
void g_dec_expression_negate(GDecExpression *);



#endif  /* _DECOMP_EXPRESSION_H */
