
/* Chrysalide - Outil d'analyse de fichiers binaires
 * switch.h - prototypes pour les aiguillages multiples du flot d'exécution
 *
 * Copyright (C) 2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_INSTR_SWITCH_H
#define _DECOMP_INSTR_SWITCH_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"



#define G_TYPE_SWITCH_INSTRUCTION               g_switch_instruction_get_type()
#define G_SWITCH_INSTRUCTION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_switch_instruction_get_type(), GSwitchInstruction))
#define G_IS_SWITCH_INSTRUCTION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_switch_instruction_get_type()))
#define G_SWITCH_INSTRUCTION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SWITCH_INSTRUCTION, GSwitchInstructionClass))
#define G_IS_SWITCH_INSTRUCTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SWITCH_INSTRUCTION))
#define G_SWITCH_INSTRUCTION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SWITCH_INSTRUCTION, GSwitchInstructionClass))



/* Définition d'un aiguillage multiple du flux d'exécution (instance) */
typedef struct _GSwitchInstruction GSwitchInstruction;

/* Définition d'un aiguillage multiple du flux d'exécution (classe) */
typedef struct _GSwitchInstructionClass GSwitchInstructionClass;


/* Indique le type défini pour un multiple aiguillage du flux d'exécution. */
GType g_switch_instruction_get_type(void);

/* Exprime un aiguillage multiple du flux selon une valeur. */
GDecInstruction *g_switch_instruction_new(GDecExpression *);

/* Ajoute un cas d'exécution à l'aiguillage multiple. */
void g_switch_instruction_add_case(GSwitchInstruction *, GDecExpression *, GDecInstruction *, vmpa_t);

/* Ajoute un cas d'exécution par défaut à l'aiguillage multiple. */
void g_switch_instruction_set_default_case(GSwitchInstruction *, GDecInstruction *);



#endif  /* _DECOMP_INSTR_SWITCH_H */
