
/* Chrysalide - Outil d'analyse de fichiers binaires
 * panels.h - prototypes pour les définitions internes liées aux panneaux
 *
 * Copyright (C) 2009-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _PANEL_PANELS_INT_H
#define _PANEL_PANELS_INT_H


#include "panel.h"



#include "../common/dllist.h"



/* Réagit à un changement du binaire courant. */
typedef void (* reload_for_new_binary_fc) (GEditorPanel *, GLoadedBinary *);

/* Réagit à un changement d'affichage principal de contenu. */
typedef void (* reload_for_new_view_fc) (GEditorPanel *, GtkViewPanel *, bool);


/* Panneaux à présenter dans l'éditeur (instance) */
struct _GEditorPanel
{
    GObject parent;                         /* A laisser en premier        */

    DL_LIST_ITEM(link);                     /* Maillon de liste chaînée    */

    const char *name;                       /* Nom du panneau              */

    reload_for_new_binary_fc reload_binary; /* Changement de binaire       */
    reload_for_new_view_fc reload_view;     /* Rechargement dû à une vue   */

    GtkWidget *widget;                      /* Composant GTK d'affichage   */

};


#define panels_list_add_tail(new, head) dl_list_add_tail(new, head, GEditorPanel, link) 
#define panels_list_for_each(pos, head) dl_list_for_each(pos, head, GEditorPanel, link) 


/* Panneaux à présenter dans l'éditeur (classe) */
struct _GEditorPanelClass
{
    GObjectClass parent;                    /* A laisser en premier        */

};



#endif  /* _PANEL_PANELS_INT_H */
